package com.example.dsosnowski.accel1;

import android.app.Activity;
import android.content.Context;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.os.Handler;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
import android.widget.Button;
import android.view.View.OnClickListener;
import android.widget.RelativeLayout;
import android.widget.TextView;
import android.widget.Toast;


//public class MainActivity extends AppCompatActivity {
public class MainActivity extends Activity implements SensorEventListener {
    private SensorManager mSensorManager;
    private Sensor mAccelerometer;

    TextView title,tv,tv1,tv2;
    Button btn_reset, btn_go;
    RelativeLayout layout;

    int sensivity = 20;
    int period = 2000;
    int max_val = 100;
    int zero_range = 10;
    int mode;

    int ix;
    int iy;
    int iz;
    int xoff;
    int yoff;
    int zoff;



    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        mSensorManager = (SensorManager) getSystemService(Context.SENSOR_SERVICE);
        mAccelerometer = mSensorManager.getDefaultSensor(Sensor.TYPE_ACCELEROMETER);

        //get layout
        layout = (RelativeLayout)findViewById(R.id.relative);

        //get textviews
        title=(TextView)findViewById(R.id.name);
        tv=(TextView)findViewById(R.id.xval);
        tv1=(TextView)findViewById(R.id.yval);
        tv2=(TextView)findViewById(R.id.zval);

        btn_reset = (Button)findViewById(R.id.button_reset);
        btn_go = (Button)findViewById(R.id.button_go);


        btn_reset.setOnClickListener(new OnClickListener() {
            public void onClick(View v) {
                xoff = ix;
                yoff = iy;
                zoff = iz;
                Toast.makeText(getBaseContext(), "Reset param", Toast.LENGTH_SHORT).show();
            }
        });

        /*btn_go.setOnClickListener(new OnClickListener() {
            public void onClick(View v) {
                Toast.makeText(getBaseContext(), "Go", Toast.LENGTH_SHORT).show();
            }
        });*/


        btn_go.setOnTouchListener(new View.OnTouchListener() {

           // private Handler mHandler;

            @Override public boolean onTouch(View v, MotionEvent event) {
                switch(event.getAction()) {
                    case MotionEvent.ACTION_DOWN:
                        mode = 1;
                        /*if (mHandler != null) return true;
                        mHandler = new Handler();
                        mHandler.postDelayed(mAction, 500);
                        */
                        break;
                    case MotionEvent.ACTION_UP:
                        mode = 0;
                        /*if (mHandler == null) return true;
                        mHandler.removeCallbacks(mAction);
                        mHandler = null;
                        */
                        break;
                }
                return false;
            }

            /*Runnable mAction = new Runnable() {
                @Override public void run() {
                    System.out.println("Performing action...");
                    mHandler.postDelayed(this, 500);
                }
            };*/

        });

    }

    @Override
    public final void onAccuracyChanged(Sensor sensor, int accuracy)
    {
        // Do something here if sensor accuracy changes.
    }

    @Override
    public final void onSensorChanged(SensorEvent event)
    {
        // Many sensors return 3 values, one for each axis.
        float x =  event.values[0];
        float y =  event.values[1];
        float z =  event.values[2];

        ix = (int)(x * sensivity);
        iy = (int)(y * sensivity);
        iz = (int)(z * sensivity);


        //display values using TextView
        if (mode == 1) {
            title.setText("   Drive!!!   ");
            int val;
            val = (ix - xoff);
            if ((val > -(zero_range)) && (val < zero_range)) val = 0;
            if (val < -(max_val)) val = -(max_val);
            if (val >  max_val) val =  max_val;
            tv.setText("X axis" +"\t\t"+val);
            val = (iy - yoff);
            if ((val > -(zero_range)) && (val < zero_range)) val = 0;
            if (val < -(max_val)) val = -(max_val);
            if (val >  max_val) val =  max_val;
            tv1.setText("Y axis" + "\t\t" +val);
            val = (iz - zoff);
            if ((val > -(zero_range)) && (val < zero_range)) val = 0;
            if (val < -(max_val)) val = -(max_val);
            if (val >  max_val) val =  max_val;
            tv2.setText("Z axis" +"\t\t" +val);
        } else {
            title.setText("    STOP      ");
            tv.setText("X axis" +"\t\t"+"0");
            tv1.setText("Y axis" +"\t\t"+"0");
            tv2.setText("Z axis" +"\t\t"+"0");
        }


    }

    @Override
    protected void onResume()
    {
        super.onResume();
        mSensorManager.registerListener(this, mAccelerometer, period);
    }

    @Override
    protected void onPause() {
        super.onPause();
        mSensorManager.unregisterListener(this);
    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }
}
